#define INCL_DOSPROCESS
#define INCL_DOSQUEUES
#define INCL_DOSERRORS
#define INCL_DOSSEMAPHORES


#include <os2.h>
#include "setup.h"
#include <deque>
#include <vector>
#include <map>
#include <string.h>


#include "helpers\stringh.h"
#include "helpers\xstring.h"
#include "base\bs_string.h"

#include "wipengine\wipebase.h"
#include "wipengine\fdu.h"
#include "wipengine\threadbase.h"
#include "wipengine\mlu.h"
#include "wipengine\arcsubsys.h"
#include "wipengine\arcunit.h"


void main (void) {
    FileVector *v = new FileVector;
    FileVector::iterator iv;
    FileDatabaseUnit f;
    FileClass fc, fc2, *fc3 = NULL;
    FileVector *filvec = new FileVector;

    fc._bssFileName = "nimi1";
    fc._bssFilePath = "polku1";
    f.InsertFile(fc);

    fc._bssFileName = "nimi2";
    fc._bssFilePath = "polku2";
    f.InsertFile(fc);


    fc._bssFileName = "nimi3";
    fc._bssFilePath = "polku3";
    f.InsertFile(fc);

    fc._bssFileName = "nimi5";
    fc._bssFilePath = "polku5";
    f.InsertFile(fc);

    fc._bssFileName = "nimi4";
    fc._bssFilePath = "polku4";
    f.InsertFile(fc);


    fc._bssFileName = "nimi3";
    fc._bssFilePath = "polku3";
    f.DeleteFile(fc);

    fc2._bssFileName = "nimi6";
    fc2._bssFilePath = "polku6";
    f.ReplaceFile(3, fc2);

    f.DeleteFile(1);

    f.QueryFiles(*v);
    iv = (*v).begin();
    for (;iv < (*v).end(); iv++) {
        printf("tulos: %s\n", (*iv)._bssFileName.c_str());
        }


    printf("\nElements in deque: %i\n", f.ReturnFileCount());

    fc3 = new FileClass();
    f.QueryFile(0, *fc3);

    printf("\nElement 0: %s\n", (*fc3)._bssFileName.c_str());

    fc3 = new FileClass();
    f.QueryFile(2, *fc3);

    printf("\nElement 1: %s\n", (*fc3)._bssFileName.c_str());



    MsgLoggingUnit log;
    MsgClass msg, msg2, msg3, msg4, *pmsg;
    USHORT us;
    MsgClass *testi;
    int i;
    MsgInfo *pMsgInfo = NULL;

    //log.SetCallBackData(callback, NULL);
    printf("Start the execution of the thread.\n");
    fflush(stdout);
    log.Start();
    printf("Message queue handler: %i\n", log._hQReceiver);
    printf("Do some tests.\n\n");
    fflush(stdout);


    BSString bssMessageString("testi");
    printf("Ekat messut.\n\n");
    fflush(stdout);
    for (i=0;i<3;i++)
        MsgLoggingUnit::LogMessage(100,
                                   bssMessageString,
                                   TYPE_MSG_INFORMATIVE,
                                   0,
                                   log._hQReceiver);


    bssMessageString = "testi 2";
    printf("Tokat messut.\n\n");
    fflush(stdout);
    for (i=0;i<10;i++)
        MsgLoggingUnit::LogMessage(200,
                                   bssMessageString,
                                   TYPE_MSG_INFORMATIVE,
                                   0,
                                   log._hQReceiver);


    MsgLoggingUnit::DeleteMessage(100, log._hQReceiver);


    ArcSubSystem asubsys(log._hQReceiver,NULL,NULL);
    asubsys.Start();

    FileVector *fv = new FileVector;
    fc._bssFileName = "nimi45";
    fc._bssFilePath = "polku45";
    fv->push_back(fc);
    fc._bssFileName = "nimi55";
    fc._bssFilePath = "polku55";
    fv->push_back(fc);
    fc._bssFileName = "nimijoo65";
    fc._bssFilePath = "polku65";
    fv->push_back(fc);
    fc._bssFileName = "nimiTerve22";
    fc._bssFilePath = "polku22";
    fv->push_back(fc);
    fc._bssFileName = "123nimi45";
    fc._bssFilePath = "312polku45";
    fv->push_back(fc);

    asubsys.InsertFiles(fv, NULLHANDLE);

    HEV _hevTest2;
    DosCreateEventSem(NULL, &_hevTest2, 0L, FALSE);
    filvec = new FileVector;
    /*pMsgInfo = new MsgInfo;
    pMsgInfo->_pData = filvec;
    pMsgInfo->_aidSender = 0;
    pMsgInfo->_hevSem = _hevTest2;
    DosWriteQueue(asubsys._hQReceiver, QUE_MSG_QUERY_FILES, sizeof(MsgInfo), (PVOID)pMsgInfo,
                      QUE_MSG_PRIORITY_NORMAL);*/
    asubsys.QueryFiles(filvec, _hevTest2);
    //asubsys.InsertFiles(*fv);
    //FileVector *fv2 = new FileVector;
    FileVector *fv2 = NULL;
    //asubsys.QueryFiles(&fv2);
    DosWaitEventSem(_hevTest2, SEM_INDEFINITE_WAIT);
    if (filvec) {
        for (i=0;i<filvec->size();i++) {
            printf("Filename: %s  Path: %s\n", (*filvec)[i]._bssFileName.c_str(), (*filvec)[i]._bssFilePath.c_str());
            fflush(stdout);
            }
        }

    FileVector::iterator ibegin, iend;
    ibegin = filvec->begin();
    iend = filvec->end();
    iend-=2;
    filvec->erase(ibegin, iend);
    //asubsys._Files.DeleteFile(3);
    //asubsys.DeleteFiles(*filvec);
    /*DosWriteQueue(asubsys._hQReceiver, QUE_MSG_DELETE_FILES, sizeof(FileVector), (PVOID)filvec,
                  QUE_MSG_PRIORITY_NORMAL);*/
    asubsys.DeleteFiles(filvec);


    DosCreateEventSem(NULL, &_hevTest2, 0L, FALSE);
    filvec = new FileVector;
    /*pMsgInfo = new MsgInfo;
    pMsgInfo->_pData = filvec;
    pMsgInfo->_aidSender = 0;
    pMsgInfo->_hevSem = _hevTest2;
    DosWriteQueue(asubsys._hQReceiver, QUE_MSG_QUERY_FILES, sizeof(MsgInfo), (PVOID)pMsgInfo,
                      QUE_MSG_PRIORITY_NORMAL);*/
    asubsys.QueryFiles(filvec, _hevTest2);
    //asubsys.InsertFiles(*fv);
    //FileVector *fv2 = new FileVector;
    //asubsys.QueryFiles(&fv2);
    DosWaitEventSem(_hevTest2, SEM_INDEFINITE_WAIT);
    if (filvec) {
        for (i=0;i<filvec->size();i++) {
            printf("Filename: %s  Path: %s\n", (*filvec)[i]._bssFileName.c_str(), (*filvec)[i]._bssFilePath.c_str());
            fflush(stdout);
            }
        }

    BSString filename("f:\testi.wpi");
    ArchiveUnit aunit(log._hQReceiver, NULL, NULL);
    AID aid = aunit.CreateArchive(filename, NULL);
    aunit.CreateArchive(filename, NULL);

    FileVector *fv200 = new FileVector;
    fc._bssFileName = "nimi45";
    fc._bssFilePath = "polku45";
    fv200->push_back(fc);
    fc._bssFileName = "nimi55";
    fc._bssFilePath = "polku55";
    fv200->push_back(fc);
    fc._bssFileName = "nimijoo65";
    fc._bssFilePath = "polku65";
    fv200->push_back(fc);
    fc._bssFileName = "nimiTerve22";
    fc._bssFilePath = "polku22";
    fv200->push_back(fc);
    fc._bssFileName = "123nimi45";
    fc._bssFilePath = "312polku45";
    fv200->push_back(fc);

    FileVector *fv300 = new FileVector;
    fc._bssFileName = "nimi45 300";
    fc._bssFilePath = "polku45 300";
    fv300->push_back(fc);
    fc._bssFileName = "nimi55 300";
    fc._bssFilePath = "polku55 300";
    fv300->push_back(fc);
    fc._bssFileName = "nimijoo65 300";
    fc._bssFilePath = "polku65 300";
    fv300->push_back(fc);
    fc._bssFileName = "nimiTerve22 300";
    fc._bssFilePath = "polku22 300";
    fv300->push_back(fc);
    fc._bssFileName = "123nimi45 300";
    fc._bssFilePath = "312polku45 300";
    fv300->push_back(fc);


    //aunit.DeleteArchive(aid);
    HEV _hevTest200;
    DosCreateEventSem(NULL, &_hevTest200, 0L, FALSE);
    aunit.AddFiles(aid, fv200, _hevTest200);
    DosWaitEventSem(_hevTest200, SEM_INDEFINITE_WAIT);
    aunit.AddFiles(aid, fv300);
    printf("oikein taas\n");
    fflush(stdout);
    filvec = new FileVector;
    //aunit.InsertFiles(aid, filvec, NULLHANDLE);


    HEV _hevTest;
    DosCreateEventSem(NULL, &_hevTest, 0L, FALSE);
    MessageVector *pv = new MessageVector;
    MsgLoggingUnit::FindMessage(NULLHANDLE,
                                pv,
                                log._hQReceiver,
                                _hevTest);



    printf("\nWait a while.\n");
    fflush(stdout);

    DosWaitEventSem(_hevTest, SEM_INDEFINITE_WAIT);
    //DosSleep(1000);
    MessageVector *tv;

    //log.FindMessages(&tv, 300);

    printf("\nPrint messages NOW!\n");
    fflush(stdout);

    if (pv) {
        for (i=0;i<pv->size();i++) {
            printf("Message type: %i  sender: %i  detail: %i  text: %s\n", (*pv)[i]._usMessageType, (*pv)[i]._aidSender, (*pv)[i]._lDetailInfo,(*pv)[i]._bssMessage.c_str());
            fflush(stdout);
            }
        }



    printf("\n The End.\n");

    //#endif
    }
