/******************************************************************************
 *@@sourcefile WIProtocol.hpp:
 *      Document me!
 *
 *@@include #include "net\WIProtocol.hpp"
 */

#ifndef WIPROTOCOL_HPP_INCLUDED
#define WIPROTOCOL_HPP_INCLUDED

#include "net\WINet.hpp"

class WIProtocol
{
  protected:
    WINet* _pwiNet;
  public:
    WIProtocol(WINet* pwiNet = NULL) { _pwiNet = pwiNet; }
    virtual ~WIProtocol()            {                   }

    virtual BOOL Fetch(WIURL& pwiURL, PCSZ pcszSavefileName, BOOL fResume) = 0;
  protected:
    BOOL Callback(USHORT usMsgType, ULONG ulMsgValue, const WIURL& wiURL)
    {
        return _pwiNet->Callback(usMsgType, ulMsgValue, wiURL);
    }
};

#endif // not WIPROTOCOL_HPP_INCLUDED
